<template>
  <v-main class="mainStyle">
    <div class="d-flex">
      <v-card class="userCard">
        <div class="m-3">
          <div class="d-flex flex-row justify-space-between">
            <h2 v-show="user.role === 'ADMIN'"><img  class="img-style mt-3" src="http://localhost:8080/api/files/avatar.jfif"> User ID: {{userId}} </h2>
            <h2 v-show="user.role === 'MANAGER'"><img  class="img-style mt-3" src="http://localhost:8080/api/files/avatar2.png"> User ID: {{userId}} </h2>
            <h2 v-show="user.role === 'USER'"><img  class="img-style mt-3" src="http://localhost:8080/api/files/avatar3.jpg"> User ID: {{userId}} </h2>
            <v-icon v-show="user.role === 'ADMIN'" color="yellow-darken-3">mdi-crown</v-icon>
            <v-icon v-show="user.role === 'MANAGER'" color="green-darken-3">mdi-card-account-details-star</v-icon>
            <v-icon v-show="user.role === 'USER'" color="blue-darken-4">mdi-card-account-details</v-icon>

          </div>
          <v-divider></v-divider>
          <p>Vorname: <strong>{{user.firstName}}</strong></p>
          <p>Nachname: <strong>{{user.lastName}}</strong></p>
          <p>Geburtstag: <strong>{{user.birthday}}</strong></p>
          <v-divider></v-divider>
          <p>E-Mail: <i><strong>{{user.email}}</strong></i></p>
          <p>Username: <i><strong>{{user.username}}</strong></i></p>
          <p>Abteilung: <i><strong>{{user.department}}</strong></i></p>
          <p v-if="user.managedDepartment">Geleitete Abteilung: <i><strong>{{user.managedDepartment}}</strong></i></p>
        </div>
        </v-card>
      <div class="ms-2">
        <v-card class="d-flex flex-column actionsCard">
          <h2 class="m-3">Aktionen</h2>
          <v-divider></v-divider>
          <v-btn class="m-2" color="blue-darken-4" @click="openEmailWindow">Nachricht schreiben</v-btn>
        </v-card>
      </div>
    </div>

    <v-card class="mt-4">
      <div class="d-flex justify-content-center">
        <h2 class="m-3">User ({{user.userId}}) Tickets ({{tickets.length}})</h2>
      </div>
      <table class="table table-bordered table-hover text-center">
        <thead>
        <tr>
          <th>Titel</th>
          <th>Beschreibung</th>
          <th>Erstellt</th>
          <th>Priorität</th>
          <th>Status</th>
          <th>Abteilung</th>
          <th>Aktionen</th>
        </tr>
        </thead>
        <tbody>
        <ticket-data
            v-for="ticket in tickets"
            :ticket="ticket"
            :page="currentPage"
        ></ticket-data>
        </tbody>
        <tr>
          <td colspan="3">
            <v-btn
                color="blue-darken-4"
                @click="prevPage"
                :disabled="currentPage === 1"><v-icon>mdi-arrow-left-drop-circle-outline</v-icon></v-btn>
          </td>
          <td colspan="2">
            <p class="border-light-subtle mt-2 text-center">Seite: {{currentPage}}</p>
          </td>
          <td colspan="3">
            <v-btn
                color="blue-darken-4"
                :disabled="tickets.length < 10"
                @click="nextPage"><v-icon>mdi-arrow-right-drop-circle-outline</v-icon></v-btn>
          </td>
        </tr>
      </table>
    </v-card>

  </v-main>

</template>

<script setup>

import {router} from "@/router";
import {useUserStore} from "@/stores/userStore";
import {computed, onMounted, ref} from "vue";
import {useTicketStore} from "@/stores/ticketStore";
import {useAuthStore} from "@/stores/authStore";
import TicketData from "@/components/TicketData.vue";

const userId = router.currentRoute.value.params.id;
const userStore = useUserStore();
const user = computed(() => userStore.user);

onMounted(async () => {
  await userStore.getSingleUser(userId);
  await fetchTickets(currentPage.value);
})


function openEmailWindow() {
  window.location.href = `mailto:${user.value.email}`;
}




//STORES
const ticketStore = useTicketStore();
const authStore = useAuthStore();

//VARIABLES
const tickets = computed(() => {
  return ticketStore.tickets.filter(ticket => ticket.resolvedBy === user.value.username
      || ticket.resolvedBy === user.value.userId);
})
const currentPage = ref(1);

//FUNCTIONS
async function fetchTickets(page) {
  await ticketStore.getTickets(page);
}

function nextPage() {
  currentPage.value++;
  fetchTickets(currentPage.value);
}

function prevPage() {
  if (currentPage.value > 0) {
    currentPage.value--;
    fetchTickets(currentPage.value);
  }
}
</script>

<style scoped>
.mainStyle{
  min-height: 100vh;
}
.userCard{
  min-width: 50vw;
  min-height: 50vh;
}

.img-style {
  width: 80px;
  border-radius: 115px;
}

.actionsCard{
  min-width: 20vw;
  min-height: 20vh;
}
</style>